import { App } from '@kevisual/router';
import { useConfig } from '@kevisual/use-config';
import { dynamicImport } from './lib/dynamic-import.ts';
import { redisPublisher, redisSubscriber, redis } from './modules/redis.ts';
import { minioClient } from './modules/minio.ts';
import { sequelize } from './modules/sequelize.ts';
import { useContextKey, useContext } from '@kevisual/use-config/context';
useConfig();
export { redis, minioClient, sequelize };

const init = () => {
  console.log('init app', global.context);
  return new App<{ import: any; sequelize: typeof sequelize }>({
    serverOptions: {
      cors: {
        origin: '*',
      },
    },
    io: true,
    routerContext: {
      import: dynamicImport,
      sequelize,
    },
  });
};
export const app = useContextKey('app', init);
